/* Copyright (c) 2008, Sheng Guo, Li-San Wang and Junhyong Kim, University of
  Pennsylvania.  All Rights Reserved.
 
  You may not use this file except in compliance with the License
  located in the top directory of this distribution.  You may obtain
  a copy of the License at
 
      http://kim.bio.upenn.edu/software/index.shtml
 
  Unless required by applicable law or agreed to in writing, this
  software is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied.  See the License
  for the specific language governing permissions and limitations
  under the License. 
*/

#ifndef EVOLUTIONTREE_H
#define EVOLUTIONTREE_H

#include "RootedTree.h"
#include "RNAWithPairing.h"
#include "Utility.h"

#include <string>
#include <vector>
#include <map>

/****************************************************************************************

  class EvolutionTree : RootedTree whose nodes are augmented with sequence & evolution event

****************************************************************************************/
class EvolutionTree{	
	
	friend class MutateOnTree;	

private:

	RootedTree * tree;
	map<RootedTreeNode *, RNAWithPairing * > objlist;	//object being mutated. map<keyType, valueType>
	//map<RootedTreeNode *, vector<int> > evhist;			//mutation events for the object

public:	

	EvolutionTree(RootedTree *);
	~EvolutionTree();
	RootedTree * getTree() const;
	void setrootobj( RNAWithPairing *);
	void eraseObj(RootedTreeNode *); 

	//void dumpresult(char * resultfilename, int resulttype, bool history=false) const;
	//void dumpresult2(char * resultfilename) const;
};

#endif
