/* Copyright (c) 2008, Sheng Guo, Li-San Wang and Junhyong Kim, University of
  Pennsylvania.  All Rights Reserved.
 
  You may not use this file except in compliance with the License
  located in the top directory of this distribution.  You may obtain
  a copy of the License at
 
      http://kim.bio.upenn.edu/software/index.shtml
 
  Unless required by applicable law or agreed to in writing, this
  software is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied.  See the License
  for the specific language governing permissions and limitations
  under the License. 
*/

/*******************************************************************************************
	class RootedTreeParser
	--Use RootedTreeParser(string) to parser the Newick string to create a RootedTree object;
	--Call parse() to return the tree structure
********************************************************************************************/

#ifndef ROOTEDTREEPARSER_H
#define ROOTEDTREEPARSER_H

#include "RootedTreeNode.h"

#include <ctype.h>
#include <string>
#include <iostream>
#include <cassert>


using namespace std;

class RootedTreeParser{

private:

	int head;
	string treestr;

public:
	
	RootedTreeParser();
	RootedTreeParser(const string &);
	
	string readLabel();		//not const function, 'head' will be changed.
	double readVal();		//not const function, 'head' will be changed.
	RootedTreeNode * parse();

};

#endif
//END_OF_FILE
